<template>
  <div class="plot-settings-area d-flex flex-grow-0 flex-column bg-light px-4 py-3" style="overflow-y: scroll; min-width: 20rem">
    <div class="d-flex flex-grow-0 flex-column" style="max-height: 0px">
      <div class="form-group pb-3">
        <small class="form-text text-muted">Pesquisar</small>
        <br>
        <input type="text" class="form-control w-100" v-model="searchFilter">
      </div>
      <div v-for="optionGroup in options" :key="`${workspaceId}-${optionGroup.name}`">
        <h4 class="pb-2">{{ optionGroup.label }}</h4>
        <div
           v-for="option in optionGroup.options"
           :key="`${workspaceId}-${option.name}`"
           class="plot-option-status-control custom-control custom-switch pb-1">
          <input
             type="checkbox"
             class="custom-control-input"
             :id="`${workspaceId}-${option.name}`"
             :value="option.name"
             :disabled="currentSelection.length > 3 && !currentSelection.includes(option.name)"
             v-model="currentSelection">
          <label class="custom-control-label plot-option-control-label" :for="`${workspaceId}-${option.name}`">
            {{ option.label }}
          </label>
        </div>
      </div>
      <div class="pb-4"/>
    </div>
  </div>
</template>

<script>
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import { SET_WORKSPACE_CURRENT_PLOT_SETTINGS } from '@/workspace/store/mutations'
import settings from '@/plots/settings'

export default {
  name: 'plotsettings',

  mixins: [
    WorkspaceGetter
  ],

  data() {
    return {
      dataPaths: { arome: [], ecmwf: [], lsasaf: [] },
      currentSelection: [],
      searchFilter: '',
    }
  },

  computed: {
    storedSelection: {
      get() {
        return this.$store.getters.workspaceCurrentPlotSettings(this.workspaceId)
      },
    },

    options: {
      get() {
        return {
          arome: {
            name: 'arome',
            label: 'AROME',
            options: this.dataPaths.arome.map((path) => {
              let resolve = settings.getSettingsForVariable(path)
              
              return {
                label: resolve.dataType.label,
                name: path
              }
            }).filter((item) => {
              return item.label.toLowerCase().includes(this.searchFilter)
            })
          },

          ecmwf: {
            name: 'ecmwf',
            label: 'ECMWF',
            options: this.dataPaths.ecmwf.map((path) => {
              let resolve = settings.getSettingsForVariable(path)
              
              return {
                label: resolve.dataType.label,
                name: path
              }
            }).filter((item) => {
              return this.searchFilter.split(' ').filter(term => {
                return term.length > 0
              }).map((searchTerm) => {
                return item.label.toLowerCase().includes(searchTerm.toLowerCase())
              }).every((testResult) => {
                return testResult === true
              })
            })
          },

          lsasaf: {
            name: 'lsasaf',
            label: 'LSASAF',
            options: this.dataPaths.lsasaf.map((path) => {
              let resolve = settings.getSettingsForVariable(path)
              
              return {
                label: resolve.dataType.label,
                name: path
              }
            }).filter((item) => {
              return this.searchFilter.split(' ').filter(term => {
                return term.length > 0
              }).map((searchTerm) => {
                return item.label.toLowerCase().includes(searchTerm.toLowerCase())
              }).every((testResult) => {
                return testResult === true
              })
            })
          }
        }
      }
    },
  },

  watch: {
    currentSelection() {
      this.$store.commit(SET_WORKSPACE_CURRENT_PLOT_SETTINGS, {
        workspaceId: this.workspaceId,
        plotSettings: this.currentSelection
      })
    }
  },

  mounted() {
    settings.getDataPaths(settings.data.arome, 'arome', this.dataPaths.arome)
    settings.getDataPaths(settings.data.ecmwf, 'ecmwf', this.dataPaths.ecmwf)
    settings.getDataPaths(settings.data.lsasaf, 'lsasaf', this.dataPaths.lsasaf)
    this.currentSelection = this.$store.getters.workspaceCurrentPlotSettings(this.workspaceId)
  },

  beforeDestroy() {
    this.$store.commit(SET_WORKSPACE_CURRENT_PLOT_SETTINGS, {
      workspaceId: this.workspaceId,
      plotSettings: this.currentSelection
    })
  },
}
</script>
